﻿using Kivii.DataAnnotations;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Kivii.Lims.Entities
{
    [Alias(Configs.TableNameReportNote)]
    [Api(Description = "报告流转")]
    public class ReportNote : EntityWithMetadata
    {
        #region 关联相关
        /// <summary>
        /// 报告Kvid
        /// </summary>
        [ApiMember(Description = "报告Kvid")]
        [DefaultEmptyGuid]
        public Guid ReportKvid { get; set; }
        #endregion

        /// <summary>
        /// 流转标题
        /// </summary>
        [ApiMember(Description = "流转标题")]
        [StringLength(100), Required]
        public string Title { get; set; }

        /// <summary>
        /// 流转类型
        /// </summary>
        [ApiMember(Description = "流转类型")]
        [StringLength(100), Default("")]
        public string Type { get; set; }

        /// <summary>
        /// 当前流程
        /// </summary>
        [ApiMember(Description = "当前流程")]
        [StringLength(100), Required]
        public string From { get; set; }

        /// <summary>
        /// 目标流程
        /// </summary>
        [ApiMember(Description = "目标流程")]
        [StringLength(100), Required]
        public string To { get; set; }

        /// <summary>
        /// 操作人
        /// </summary>
        [ApiMember(Description = "操作人")]
        [StringLength(100), Default("")]
        public string OperatorName { get; set; }

        /// <summary>
        /// 操作人Kvid
        /// </summary>
        [ApiMember(Description = "操作人Kvid")]
        public Guid OperatorKvid { get; set; }

        /// <summary>
        /// 操作日期
        /// </summary>
        [ApiMember(Description = "操作日期")]
        public DateTime OperateTime { get; set; }

        /// <summary>
        /// 摘要
        /// </summary>
        [ApiMember(Description = "摘要")]
        [StringLength(1000), Default("")]
        public string Summary { get; set; }

        /// <summary>
        /// IP地址
        /// </summary>
        [ApiMember(Description = "IP地址")]
        [StringLength(100), Default(""),IgnoreUpdate]
        [CurrentIpAddress]
        public string IP { get; set; }
    }

    public class ReportNoteEx : ReportNote
    {
        public string ReportId { get; set; }

        public string ReportOperatorName { get; set; }
        public string ReportPreparerName { get; set; }
    }
}
