﻿using Kivii.Lims.Entities;
using Kivii.Lac.Lims.Transforms;
using Kivii.Linq;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Kivii.Lac.Lims.Services
{
    public class ReportService : Service
    {
        public object Any(ReportPdf request)
        {
            request.Code.ThrowIfNullOrEmpty("请传入验证码{Code}");
            request.ReportId.ThrowIfNullOrEmpty("请传入报告号{ReportId}.Pdf");
            var conn = KiviiContext.GetOpenedDbConnection<Report>();
            var queryReportKvid = conn.From<Report>();
            queryReportKvid.Where(o => o.ReportId == request.ReportId);
            queryReportKvid.Select(o => o.Kvid);
            var reportKvid = conn.Single<Guid>(queryReportKvid);
            reportKvid.ThrowIfEmpty($"未找到此报告{request.ReportId}");
            (!reportKvid.ToString().ToLower().StartsWith(request.Code.ToLower())).ThrowIfTrue("验证码Code 不正确!");

            var queryPdfEntityFile = conn.From<EntityDbFile<Report>>();
            queryPdfEntityFile.Where(o => o.OwnerKvid == reportKvid && o.ParentKvid == Guid.Empty && o.Extension.ToLower() == ".pdf"&&o.DbFolderPath == "/Reports/Pdf");
            var pdfEntityFile = conn.Single(queryPdfEntityFile);
            (pdfEntityFile == null).ThrowIfTrue("未找到文件");
            if (request.View.IsNullOrEmpty())
            {
                var physicalFilePath = pdfEntityFile.GetPhysicalPath();
                var fileInfo = new FileInfo(physicalFilePath);
                return new HttpResult(fileInfo, asAttachment: request.Download, fileName: pdfEntityFile.Name);//asAttachment是否直接下载,fileName文件名称
            }
            var virtualFilePath = pdfEntityFile.GetVirtualPath();
            pdfEntityFile.Path = virtualFilePath;
            return new HttpResult
            {
                Response = pdfEntityFile,
                View = request.View
            };

        }
    }
}
