﻿using Kivii.Lims.Entities;
using Kivii.Linq;
using Kivii.Web;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Kivii.Lac.Lims.Transforms
{
    [RequiresAnyRole(SystemRoles.Everyone)]
    public class ReportFileQuery:RestfulQuery<ReportFile>
    {
    }
    [RequiresAnyRole(SystemRoles.Everyone)]
    public class ReportFileUpdate : RestfulUpdate<ReportFile>
    {
    }
    [RequiresAnyRole(SystemRoles.Everyone)]
    public class ReportFileDelete : RestfulDelete<ReportFile>
    {
    }
    [RequiresAnyRole(SystemRoles.Everyone)]
    public class ReportFileUpdateSortId : RestfulExecution<ReportFile>
    {
        public List<ReportFile> reportFiles { get; set; }
        public override object OnExecution(IRequest req, IResponse res)
        {
            #region 数据验证
            (reportFiles.Count == 0).ThrowIfTrue("未传入操作数据!");
            #endregion
            var conn = KiviiContext.GetOpenedDbConnection<ReportFile>();
            var rtns = new RestfulQueryResponse<ReportFile>();
            rtns.Results = new List<ReportFile>();
            foreach (var reportFile in reportFiles)
            {
                reportFile.AddOnlyProperties(o=>o.SortID);
                conn.UpdateOnly(reportFile);
                rtns.Results.Add(reportFile);
            }
            rtns.Total = rtns.Results.Count;
            return rtns;
        }
    }
}
