﻿using Kivii.Lims.Entities;
using Kivii.Linq;
using Kivii.Web;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Kivii.Lac.Lims.Transforms
{
    [RequiresAnyRole(SystemRoles.Administrator, SystemRoles.Manager, SystemRoles.Configuration)]
    public class TemplateCreate : RestfulCreate<Template>
    { }

    [RequiresAnyRole(SystemRoles.Administrator, SystemRoles.Manager, SystemRoles.Configuration)]
    public class TemplateRead : RestfulRead<Template>
    { }

    [RequiresAnyRole(SystemRoles.Administrator, SystemRoles.Manager, SystemRoles.Configuration)]
    public class TemplateUpdate : RestfulUpdate<Template>
    { }

    [RequiresAnyRole(SystemRoles.Administrator, SystemRoles.Manager, SystemRoles.Configuration)]
    public class TemplateDelete : RestfulDelete<Template>
    { }

    [RequiresAnyRole(SystemRoles.Administrator, SystemRoles.Manager, SystemRoles.Configuration)]
    public class TemplateQuery : RestfulQuery<Template>
    { }

    [RequiresAnyRole(SystemRoles.Everyone)]
    public class TemplateQueryByCustomer : RestfulExecution<Template>
    {
        public List<Guid> CustomerKvids { get; set; }
        public override object OnExecution(IRequest req, IResponse res)
        {
            var rtns = new RestfulQueryResponse<Template>();
            rtns.Results = new List<Template>();
            var conn = KiviiContext.GetOpenedDbConnection<Template>();
            var queryRelatedTemplateKvid = conn.From<EntityRelation<Template>>();
            queryRelatedTemplateKvid.Where(o => o.RelationType == "Kivii.Customers.Entities.Customer" && Sql.In(o.RelationKvid, CustomerKvids));
            queryRelatedTemplateKvid.SelectDistinct(o => o.EntityKvid);
            var queryTemplate = conn.From<Template>();
            queryTemplate.Where(o => o.EffectiveTime <= DateTime.Now && (o.ExpiredTime >= DateTime.Now||o.ExpiredTime == null));
            queryTemplate.Where(o => o.Type == TemplateType.Common || Sql.In(o.Kvid, queryRelatedTemplateKvid));
            queryTemplate.OrderBy(o => o.SortId);
            rtns.Results = conn.Select(queryTemplate);
            rtns.Total = rtns.Results.Count;
            return rtns;
        }
    }
}
