﻿using Kivii.Lims.Entities;
using Kivii.Linq;
using Kivii.Web;
using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Kivii.Lac.Lims.Transforms
{
    [RequiresAnyRole(SystemRoles.Administrator, SystemRoles.Manager, SystemRoles.Configuration)]
    public class TemplateDetailCreate : RestfulCreate<TemplateDetail>
    {
        public override bool OnPreRestfulCreate(IRequest req, IResponse res, IDbConnection dbConnection, IRestfulCreateResponse<TemplateDetail> rtns)
        {
            #region 项目类型判断
            if (Item.ParentKvid != Guid.Empty)
            {
                var parentNode = dbConnection.SingleById<TemplateDetail>(Item.ParentKvid);
                if (parentNode != null)
                {
                    (parentNode.Type == TemplateDetailType.Unsupported).ThrowIfTrue("未知项下不可建立子项!");
                    if (parentNode.Type == TemplateDetailType.Test)
                    {
                        (Item.Type != TemplateDetailType.Test).ThrowIfTrue($"此项下不可建立当前类型{Item.Type}!");
                        parentNode.Type = TemplateDetailType.TestFolder;
                        parentNode.AddOnlyProperties(o => o.Type);
                        dbConnection.UpdateOnly(parentNode);
                    }
                }
                else Item.ParentKvid = Guid.Empty;
            }
            #endregion
            Item.AddOnlyProperties(o => o.Status);
            return base.OnPreRestfulCreate(req, res, dbConnection, rtns);
        }
    }
    [RequiresAnyRole(SystemRoles.Administrator, SystemRoles.Manager, SystemRoles.Configuration)]
    public class TemplateDetailRead : RestfulRead<TemplateDetail>
    { }

    [RequiresAnyRole(SystemRoles.Administrator, SystemRoles.Manager, SystemRoles.Configuration)]
    public class TemplateDetailUpdate : RestfulUpdate<TemplateDetail>
    { }

    [RequiresAnyRole(SystemRoles.Administrator, SystemRoles.Manager, SystemRoles.Configuration)]
    public class TemplateDetailDelete : RestfulDelete<TemplateDetail>
    { }

    [RequiresAnyRole(SystemRoles.Administrator, SystemRoles.Manager, SystemRoles.Configuration)]
    public class TemplateDetailQuery : RestfulQuery<TemplateDetail>
    { }
}
